<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

/** 
 * Table of Contents
 * 
 * 1. Shortcode
 * 2. Elementor Widget Creator
 */

//1. Shortcode
function bpac_builder($params, $content) {
    extract( shortcode_atts( 
        array(
            
            'version'                    => '',
            'max_guests'                 => '',
            'color'                      => '',
            'color_hover'                => '',
            'bg_color'                   => '',
            'bg_color_hover'             => '',
            'submit_button_label'        => '',
            'property_link'                => '',
            'bg_form'                    => '',
            'color_label'                => '',
            'powered_by'                => '',
            'title'                => '',

        ), $params ) ); 

        // CSS
        wp_enqueue_style( 'bpac-custom', plugins_url( 'assets/css/custom.css', __FILE__ ), array(), '1.0.0', 'all' );
        wp_enqueue_style( 'pignose-calendar', plugins_url( 'assets/css/pignose.calendar.min.css', __FILE__ ), array(), '1.0.0', 'all' );
        // JS
        wp_enqueue_script( 'bpac-custom', plugins_url( 'assets/js/custom.js', __FILE__ ), array(), '1.0.0', 'all' );
        wp_enqueue_script( 'pignose-calendar', plugins_url( 'assets/js/pignose.calendar.full.min.js', __FILE__ ), array(), '1.0.0', 'all' );
        
	    ob_start(); 

            $checkin_id = uniqid('check-out-date-');
            $checkout_id = uniqid('check-out-date-');
            $adults_id = uniqid('adults-number-');
            $children_id = uniqid('children-number-');
            $children_age = uniqid('children-age-');
            $rooms_id = uniqid('rooms-number-');
            ?>
            <div class="mt-booking-property-availability-checker-form">
                <form action="<?php echo esc_url($property_link); ?>" method="get">
                    <div class="bpac_row bpac_row-<?php echo esc_attr($version); ?>">
                        <span class="bpac-heading"><?php echo esc_attr($title); ?></span>
                        <div class="bpac_input_wrapper">
                            <div class="bpac-date-wrapper">
                                <div class="mt_single_builder_field mt_field--input_datepicker">
                                    <?php ?>
                                    <label for="<?php echo esc_attr($checkin_id); ?>"><?php echo esc_html__('Check In', 'bpac'); ?></label>
                                    <input id="<?php echo esc_attr($checkin_id); ?>" format="yy-mm-dd" autocomplete="off" required type="text" value="" name="checkin" placeholder="eg: yy-mm-dd" class="form-control datepicker calendar-input" />
                                </div>
                                <div class="mt_single_builder_field mt_field--input_datepicker">
                                    <label for="<?php echo esc_attr($checkout_id); ?>"><?php echo esc_html__('Check Out', 'bpac'); ?></label>
                                    <input id="<?php echo esc_attr($checkout_id); ?>" format="yy-mm-dd" autocomplete="off" required type="text" value="" name="checkout" placeholder="eg: yy-mm-dd" class="form-control datepicker calendar-input" />
                                </div>
                            </div>
                            <div class="mt_single_builder_field mt_field--input_number">
                                <label for="<?php echo esc_attr($adults_id); ?>"><?php echo esc_html__('Adults', 'bpac'); ?></label>
                                <input id="<?php echo esc_attr($adults_id); ?>" name="group_adults" required type="number" value name="adults" min="1" max="<?php echo esc_attr($max_guests); ?>" placeholder="<?php echo esc_attr('Age 13+', 'bpac'); ?>" class="form-control" />
                            </div>
                            <div class="mt_single_builder_field mt_field--input_number">
                                <label for="<?php echo esc_attr($children_id); ?>"><?php echo esc_html__('Children', 'bpac'); ?></label>
                                <input id="<?php echo esc_attr($children_id); ?>" name="group_children" type="number" value name="children" max="<?php echo esc_attr($max_guests); ?>" placeholder="<?php echo esc_attr('Ages 2–12', 'bpac');?>" class="form-control" />
                            </div>
                            <div class="mt_single_builder_field mt_field--input_number">
                                <label for="<?php echo esc_attr($rooms_id); ?>"><?php echo esc_html__('Rooms', 'bpac'); ?></label>
                                <input id="<?php echo esc_attr($rooms_id); ?>" name="no_rooms" required type="number" value name="no_rooms" placeholder="<?php echo esc_attr('Number of rooms', 'bpac'); ?>" class="form-control" />
                            </div>
                            <?php if($version == "v2"){ ?>
                                <div class="bpac-btn-group">
                                    <input type="submit" formtarget="_blank" class="rippler rippler-default button-winona btn btn-lg tabs_button bpac-submit" style="background-color:<?php echo esc_attr($bg_color);?>; color:<?php echo esc_attr($color);?>" value="<?php echo esc_attr($submit_button_label);?>" />
                                </div>
                            <?php } ?>
                        </div>
                        <?php if($version == "v1"){ ?>
                            <div class="bpac-btn-group">
                                <input type="submit" formtarget="_blank" class="rippler rippler-default button-winona btn btn-lg tabs_button bpac-submit" style="background-color:<?php echo esc_attr($bg_color);?>; color:<?php echo esc_attr($color);?>" value="<?php echo esc_attr($submit_button_label); ?>" />
                            </div>
                        <?php } ?>
                    </div> 
                    <?php if($powered_by == "yes") { ?>                      
                        <div class="bpac-footer-span">
                            <p class="bpac-p1"><?php echo esc_attr('Powered by ', 'bpac'); ?>
                                <span class="bpac-p2"><?php echo esc_attr('Booking.com', 'bpac'); ?></span>
                            </p>
                        </div>
                    <?php } ?>
                </form>
            </div>
            <?php

	    return ob_get_clean();
	}
add_shortcode('bpac-builder-shortcode', 'bpac_builder');


// 2. Elementor Widget Creator
if (in_array('elementor/elementor.php', apply_filters('active_plugins', get_option('active_plugins')))) {
	class BPAC_Elementor_Widgets {

		protected static $instance = null;

		public static function get_instance() {
			if ( ! isset( static::$instance ) ) {
				static::$instance = new static;
			}

			return static::$instance;
		}

		protected function __construct() {
			require_once('elementor.php');

			add_action( 'elementor/widgets/widgets_registered', [ $this, 'register_widgets' ] );
		}

		public function register_widgets() {
			\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new \Elementor\BPAC_Widget() );
		}

	}

	// Elementor Init
	add_action( 'init', 'bpac_elementor_init' );
	function bpac_elementor_init() {
		BPAC_Elementor_Widgets::get_instance();
	}

	// Elementor Widgets Category
	function bpac_widget_categories( $elements_manager ) {
		$elements_manager->add_category(
			'modeltheme-widgets',
			[
				'title' => esc_html__( 'Modeltheme Widgets', 'bpac' ),
				'icon' => 'fas fa-plug',
			]
		);
	}
	add_action( 'elementor/elements/categories_registered', 'bpac_widget_categories' );
}

